{ KOL MCK }// Do not remove this line!
{$DEFINE KOL_MCK}
unit Unit1;

interface

{$IFDEF KOL_MCK}
uses Windows, Messages, ShellAPI, KOL{$IFNDEF KOL_MCK}, mirror, Classes, Controls, mckControls, mckObjs, Graphics, mckCtrls,
  StdCtrls{$ENDIF};
{$ELSE}
{$I uses.inc}
Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
Dialogs;
{$ENDIF}

type
{$IFDEF KOL_MCK}
{$I MCKfakeClasses.inc}
{$IFDEF KOLCLASSES}TForm1 = class; PForm1 = TForm1; {$ELSE OBJECTS}PForm1 = ^TForm1; {$ENDIF CLASSES/OBJECTS}
{$IFDEF KOLCLASSES}{$I TForm1.inc}{$ELSE}TForm1 = object(TObj){$ENDIF}
    Form: PControl;
{$ELSE not_KOL_MCK}
  TForm1 = class(TForm)
{$ENDIF KOL_MCK}
    KOLProject1: TKOLProject;
    KOLForm1: TKOLForm;
    lvwList: TKOLListView;
    GroupBox1: TKOLGroupBox;
    btnFreeMem: TKOLButton;
    btnRefresh: TKOLButton;
    cbExpert: TKOLCheckBox;
    procedure btnRefreshClick(Sender: PObj);
    procedure KOLForm1FormCreate(Sender: PObj);
    procedure cbExpertClick(Sender: PObj);
    procedure btnFreeMemClick(Sender: PObj);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1{$IFDEF KOL_MCK}: PForm1{$ELSE}: TForm1{$ENDIF};

{$IFDEF KOL_MCK}
procedure NewForm1(var Result: PForm1; AParent: PControl);
{$ENDIF}

function StrFormatByteSizeA(value: DWORD; buffer: Pointer; bsize: DWORD): PChar; stdcall; external 'shlwapi.dll';

implementation

uses
  TlHelp32, PsAPI;

{$IFNDEF KOL_MCK}{$R *.DFM}{$ENDIF}

{$IFDEF KOL_MCK}
{$I Unit1_1.inc}
{$ENDIF}

procedure TForm1.btnRefreshClick(Sender: PObj);
var
  index: Integer;
  hsnap: THandle;
  ret: LongBool;
  process: TProcessEntry32;
  hProcess: THandle;
  tstr: string;
  pmc: TProcessMemoryCounters;
  buffer: array[0..31] of Char;
  count: Integer;
begin
  lvwList.Clear;
  hsnap := CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0);
  if hsnap = 0 then
    Exit;
  ret := Process32First(hsnap, process);
  if ret = False then
    Exit;
  count := 0;
  repeat
    if count > 2 then begin
      hProcess := OpenProcess(PROCESS_ALL_ACCESS, False, process.th32ProcessID);
      if hProcess <> 0 then begin
        FillChar(pmc, sizeof(TProcessMemoryCounters), 0);
        pmc.cb := sizeof(TProcessMemoryCounters);
        if GetProcessMemoryInfo(hProcess, @pmc, sizeof(TProcessMemoryCounters)) = true then begin
          tstr := PChar(@process.szExeFile[0]);
          index := lvwList.LVAdd(ExtractFileName(tstr), I_SKIP, [], I_SKIP, I_SKIP, process.th32ProcessID);
          tstr := StrFormatByteSizeA(pmc.WorkingSetSize, @buffer[0], 32);
          lvwList.LVSetItem(index, 1, tstr, I_SKIP, [], I_SKIP, I_SKIP, 0);
          tstr := StrFormatByteSizeA(pmc.PagefileUsage, @buffer[0], 32);
          lvwList.LVSetItem(index, 2, tstr, I_SKIP, [], I_SKIP, I_SKIP, 0);
        end;
        CloseHandle(hProcess);
      end;
    end;
    Inc(count);
    ret := Process32Next(hsnap, process);
  until ret = False;
end;

procedure TForm1.KOLForm1FormCreate(Sender: PObj);
begin
  self.Form.Icon := LoadIcon(hInstance, 'ICON');
  btnRefresh.Click;
end;

procedure TForm1.cbExpertClick(Sender: PObj);
var
  token: DWORD;
  pri: TTokenPrivileges;
  ret: DWORD;
begin
  if not OpenProcessToken(GetCurrentProcess, TOKEN_ADJUST_PRIVILEGES, token) then
    Exit;
  pri.PrivilegeCount := 1;
  LookupPrivilegeValue(nil, 'SeDebugPrivilege', pri.Privileges[0].Luid);
  if cbExpert.Checked then
    pri.Privileges[0].Attributes := 2
  else
    pri.Privileges[0].Attributes := 1;
  AdjustTokenPrivileges(token, False, pri, 0, nil, ret);
  CloseHandle(token);
  btnRefresh.Click;
end;

procedure TForm1.btnFreeMemClick(Sender: PObj);
var
  I: Integer;
  hProcess: THandle;
begin
  btnFreeMem.Enabled := False;
  for I := 0 to lvwList.Count - 1 do // Iterate
  begin
    hProcess := OpenProcess(PROCESS_ALL_ACCESS, False, lvwList.LVItemData[i]);
    if hProcess <> 0 then begin
      SetProcessWorkingSetSize(hProcess, $FFFFFFFF, $FFFFFFFF);
      CloseHandle(hProcess);
    end;
  end; // for
  btnFreeMem.Enabled := True;
  btnRefresh.Click;
end;

end.

